/***************************************************************************
                          formstruct.h  -  description
                             -------------------
    begin                : Mon Dec 22 2003
    copyright            : (C) 2003 by Breakout Box Developer
    email                : bbdev@LinuxDev2
 ***************************************************************************/

#ifndef FORMSTRUCT_H
#define FORMSTRUCT_H

/**
  *@author Breakout Box Developer
  */
#include <stdint.h>
#include <string>
#include <vector>
#include <microwin/nano-X.h>

using namespace std;
namespace GUI {

struct formLook {
  uint16_t width;
  uint16_t height;
  uint16_t leftMargin;
  uint16_t rightMargin;
  uint16_t topMargin;
  uint16_t bottomMargin;
  uint16_t padding;
  uint8_t normalFntSize;
  uint8_t hdrFntSize;
  uint8_t dbTitleFntSize;
  uint8_t optionFntSize;
  uint8_t statusFntSize;
  uint16_t grpBorder;
  uint8_t paramCols;
  uint8_t paramRows;

  bool operator==(const formLook& rhs);
  bool operator!=(const formLook& rhs);
};

struct formKeys {
  uint16_t enter;
  uint16_t back;
  uint16_t up;
  uint16_t down;

  bool operator==(const formKeys& rhs);
  bool operator!=(const formKeys& rhs);
};

struct formData {
  string brand;
  string title;
  string databaseUsed;
  string navigationHint;
  string prompt;
  vector<string> optionList;
  vector<string> optionTips;
  string instructions;
  //formKeys key;

  bool operator==(const formData& rhs);
  bool operator!=(const formData& rhs);
};

/*
struct formStruct {
  formLook look;
  formData data;
  menuData menu;
  void (*callback)(Fl_Widget *, long);

  const formStruct& operator=(const formStruct& rhs);
  bool operator==(const formStruct& rhs);
  bool operator!=(const formStruct& rhs);
};
*/
struct formText {
  string text;
  int x, y, w, h, bh;
  GR_FONT_ID fontId;
  GR_SIZE fontSize;
  bool damage;
  
  const char* c_str() { return text.c_str(); };
  const formText& operator=(const char* rhs);
  const formText& operator=(const string& rhs);
  const formText& operator+=(const char* rhs);
  const formText& operator+=(const string& rhs);
  bool operator==(const string& rhs) { return (text==rhs); };
  bool operator!=(const string& rhs) { return (text!=rhs); };
  bool operator==(const formText& rhs);
  bool operator!=(const formText& rhs);
};

}
#endif
